diff --git a/src/departures_gui.h b/src/departures_gui.h
new file mode 100644
--- /dev/null
+++ b/src/departures_gui.h
@@ -0,0 +1,35 @@
+/* $Id: departures_gui.h $ */
+
+/*
+ * This file is part of OpenTTD.
+ * OpenTTD is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 2.
+ * OpenTTD is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ * See the GNU General Public License for more details. You should have received a copy of the GNU General Public License along with OpenTTD. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/** @file departures_gui.h */
+
+#ifndef DEPARTURES_GUI_H
+#define DEPARTURES_GUI_H
+
+#include "departures_type.h"
+#include "station_base.h"
+
+/** Enum for DeparturesView, referring to _nested_departures_list */
+enum DeparturesWindowWidgets {
+	DW_WIDGET_CAPTION,		///< Window caption
+	DW_WIDGET_LIST,			///< List of departures
+	DW_WIDGET_SCROLLBAR,	///< List scrollbar
+	DW_SHOW_DEPS,           ///< Toggle departures button
+	DW_SHOW_ARRS,           ///< Toggle arrivals button
+	DW_SHOW_VIA,            ///< Toggle via button
+	DW_SHOW_TRAINS,         ///< Toggle trains button
+	DW_SHOW_ROADVEHS,       ///< Toggle road vehicles button
+	DW_SHOW_SHIPS,          ///< Toggle ships button
+	DW_SHOW_PLANES,         ///< Toggle planes button
+};
+
+void ShowStationDepartures(StationID station);
+void ShowWaypointDepartures(StationID waypoint);
+
+#endif /* DEPARTURES_GUI_H */
diff --git a/src/departures_type.h b/src/departures_type.h
new file mode 100644
--- /dev/null
+++ b/src/departures_type.h
@@ -0,0 +1,51 @@
+/* $Id: departures_type.h $ */
+
+/*
+ * This file is part of OpenTTD.
+ * OpenTTD is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 2.
+ * OpenTTD is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ * See the GNU General Public License for more details. You should have received a copy of the GNU General Public License along with OpenTTD. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/** @file departures_type.h Types related to departures. */
+
+#ifndef DEPARTURES_TYPE_H
+#define DEPARTURES_TYPE_H
+
+#include "station_base.h"
+#include "order_base.h"
+
+/** Whether or not a vehicle has arrived for a departure. */
+typedef enum {
+	D_TRAVELLING = 0,
+	D_ARRIVED    = 1,
+	D_CANCELLED  = 2,
+} DepartureStatus;
+
+/** The type of departures. */
+typedef enum {
+	D_DEPARTURE = 0,
+	D_ARRIVAL   = 1,
+} DepartureType;
+
+/** A scheduled departure. */
+typedef struct Departure {
+	DateTicks scheduled_date;              ///< The date this departure is scheduled to finish on (i.e. when the vehicle leaves the station)
+	DateTicks lateness;                    ///< How delayed the departure is expected to be
+	StationID terminus;                    ///< The station at which the vehicle will terminate following this departure
+	StationID via;                         ///< The station the departure should list as going via
+	SmallVector<StationID, 32> calling_at; ///< The stations both called at and unloaded at by the vehicle after this departure before it terminates
+	DepartureStatus status;                ///< Whether the vehicle has arrived yet for this departure
+	DepartureType type;                    ///< The type of the departure (departure or arrival)
+	const Vehicle *vehicle;                ///< The vehicle performing this departure
+	const Order *order;                    ///< The order corresponding to this departure
+	Departure() : terminus(INVALID_STATION), via(INVALID_STATION), calling_at(), vehicle(NULL) { }
+	~Departure()
+	{
+		calling_at.Reset();
+	}
+} Departure;
+
+typedef SmallVector<Departure*, 32> DepartureList;
+
+#endif /* DEPARTURES_TYPE_H */
diff --git a/src/depot.cpp b/src/depot.cpp
--- a/src/depot.cpp
+++ b/src/depot.cpp
@@ -17,12 +17,32 @@
 #include "core/pool_func.hpp"
 #include "vehicle_gui.h"
 #include "vehiclelist.h"
+#include "road_map.h"
+#include "rail_map.h"
+#include "water_map.h"
+#include "station_map.h"
+#include "depot_map.h"
 
 /** All our depots tucked away in a pool. */
 DepotPool _depot_pool("Depot");
 INSTANTIATE_POOL_METHODS(Depot)
 
 /**
+ * Returns the direction the exit of the depot on the given tile is facing.
+ */
+DiagDirection GetDepotDirection(TileIndex tile, TransportType type)
+{
+	assert(IsDepotTypeTile(tile, type));
+
+	switch (type) {
+		case TRANSPORT_RAIL:  return GetRailDepotDirection(tile);
+		case TRANSPORT_ROAD:  return GetRoadDepotDirection(tile);
+		case TRANSPORT_WATER: return GetShipDepotDirection(tile);
+		default: return INVALID_DIAGDIR; /* Not reached */
+	}
+}
+
+/**
  * Clean up a depot
  */
 Depot::~Depot()
diff --git a/src/depot_gui.cpp b/src/depot_gui.cpp
--- a/src/depot_gui.cpp
+++ b/src/depot_gui.cpp
@@ -28,6 +28,8 @@
 #include "window_gui.h"
 #include "vehiclelist.h"
 #include "order_backup.h"
+#include "company_base.h"
+#include "infrastructure_func.h"
 
 #include "table/strings.h"
 
@@ -141,7 +143,7 @@
 
 	const Vehicle *v = Vehicle::Get(_new_vehicle_id);
 
-	ShowVehicleViewWindow(v);
+	if (!_ctrl_pressed) ShowVehicleViewWindow(v);
 }
 
 static void TrainDepotMoveVehicle(const Vehicle *wagon, VehicleID sel, const Vehicle *head)
@@ -676,7 +678,7 @@
 
 		/* Setup disabled buttons. */
 		TileIndex tile = this->window_number;
-		this->SetWidgetsDisabledState(!IsTileOwner(tile, _local_company),
+		this->SetWidgetsDisabledState(!Company::IsValidID(_local_company) || !IsInfraTileUsageAllowed(this->type, _local_company, tile),
 			DEPOT_WIDGET_STOP_ALL,
 			DEPOT_WIDGET_START_ALL,
 			DEPOT_WIDGET_SELL,
@@ -715,7 +717,7 @@
 						SPR_CURSOR_CLONE_SHIP, SPR_CURSOR_CLONE_AIRPLANE
 					};
 
-					SetObjectToPlaceWnd(clone_icons[this->type], PAL_NONE, HT_VEHICLE, this);
+					SetObjectToPlaceWnd(clone_icons[this->type], PAL_NONE, HT_VEHICLE | HT_RECT, this);
 				} else {
 					ResetObjectToPlace();
 				}
diff --git a/src/depot_map.h b/src/depot_map.h
--- a/src/depot_map.h
+++ b/src/depot_map.h
@@ -55,4 +55,6 @@
 	return _m[t].m2;
 }
 
+DiagDirection GetDepotDirection(TileIndex tile, TransportType type);
+
 #endif /* DEPOT_MAP_H */
diff --git a/src/disaster_cmd.cpp b/src/disaster_cmd.cpp
--- a/src/disaster_cmd.cpp
+++ b/src/disaster_cmd.cpp
@@ -43,6 +43,7 @@
 #include "company_base.h"
 #include "core/random_func.hpp"
 #include "core/backup_type.hpp"
+#include "aircraft.h"
 
 #include "table/strings.h"
 
@@ -122,6 +123,24 @@
 	_disaster_images_4, _disaster_images_5,                     ///< small and big submarine sprites
 };
 
+static inline void AdjustFlyingDisasterVehicleHeight(DisasterVehicle *v)
+{
+	int min_altitude = GetAircraftMinAltitude(v->x_pos, v->y_pos, 0);
+	int max_altitude = GetAircraftMaxAltitude(v->x_pos, v->y_pos, 0);
+	int middle_altitude = min_altitude + ((uint)(max_altitude - min_altitude)) / 2;
+	if (v->z_pos < min_altitude || (v->in_min_height_correction && v->z_pos < middle_altitude)) {
+		v->in_min_height_correction = true;
+		v->z_pos += 2;
+	} else if (v->z_pos > max_altitude || (v->in_max_height_correction && v->z_pos > middle_altitude)) {
+		v->in_max_height_correction = true;
+		v->z_pos -= 2;
+	} else if (v->in_min_height_correction && v->z_pos >= middle_altitude) {
+		v->in_min_height_correction = false;
+	} else if (v->in_max_height_correction && v->z_pos <= middle_altitude) {
+		v->in_max_height_correction = false;
+	}
+}
+
 static void DisasterVehicleUpdateImage(DisasterVehicle *v)
 {
 	SpriteID img = v->image_override;
@@ -202,6 +221,7 @@
 
 		GetNewVehiclePosResult gp = GetNewVehiclePos(v);
 
+		AdjustFlyingDisasterVehicleHeight(v);
 		SetDisasterVehiclePos(v, gp.x, gp.y, v->z_pos);
 
 		if (v->current_order.GetDestination() == 1) {
@@ -298,6 +318,7 @@
 		if (Delta(x, v->x_pos) + Delta(y, v->y_pos) >= (int)TILE_SIZE) {
 			v->direction = GetDirectionTowards(v, x, y);
 			GetNewVehiclePosResult gp = GetNewVehiclePos(v);
+			AdjustFlyingDisasterVehicleHeight(v);
 			SetDisasterVehiclePos(v, gp.x, gp.y, v->z_pos);
 			return true;
 		}
@@ -337,6 +358,7 @@
 		uint dist = Delta(v->x_pos, u->x_pos) + Delta(v->y_pos, u->y_pos);
 
 		if (dist < TILE_SIZE && !(u->vehstatus & VS_HIDDEN) && u->breakdown_ctr == 0) {
+			u->breakdown_type = BREAKDOWN_CRITICAL;
 			u->breakdown_ctr = 3;
 			u->breakdown_delay = 140;
 		}
@@ -402,6 +424,7 @@
 	v->image_override = (v->current_order.GetDestination() == 1 && HasBit(v->tick_counter, 2)) ? image_override : 0;
 
 	GetNewVehiclePosResult gp = GetNewVehiclePos(v);
+	AdjustFlyingDisasterVehicleHeight(v);
 	SetDisasterVehiclePos(v, gp.x, gp.y, v->z_pos);
 
 	if ((leave_at_top && gp.x < (-10 * (int)TILE_SIZE)) || (!leave_at_top && gp.x > (int)(MapSizeX() * TILE_SIZE + 9 * TILE_SIZE) - 1)) {
@@ -499,6 +522,7 @@
 			v->direction = GetDirectionTowards(v, x, y);
 
 			GetNewVehiclePosResult gp = GetNewVehiclePos(v);
+			AdjustFlyingDisasterVehicleHeight(v);
 			SetDisasterVehiclePos(v, gp.x, gp.y, v->z_pos);
 			return true;
 		}
@@ -523,6 +547,7 @@
 				if (Delta(target->x_pos, v->x_pos) + Delta(target->y_pos, v->y_pos) <= 12 * (int)TILE_SIZE) {
 					target->breakdown_ctr = 5;
 					target->breakdown_delay = 0xF0;
+					target->breakdown_type = BREAKDOWN_CRITICAL;
 				}
 			}
 		}
@@ -554,6 +579,7 @@
 		if (Delta(x, v->x_pos) + Delta(y, v->y_pos) >= (int)TILE_SIZE) {
 			v->direction = GetDirectionTowards(v, x, y);
 			GetNewVehiclePosResult gp = GetNewVehiclePos(v);
+			AdjustFlyingDisasterVehicleHeight(v);
 			SetDisasterVehiclePos(v, gp.x, gp.y, v->z_pos);
 			return true;
 		}
@@ -589,6 +615,7 @@
 	v->tick_counter++;
 
 	GetNewVehiclePosResult gp = GetNewVehiclePos(v);
+	AdjustFlyingDisasterVehicleHeight(v);
 	SetDisasterVehiclePos(v, gp.x, gp.y, v->z_pos);
 
 	if (gp.x > (int)(MapSizeX() * TILE_SIZE + 9 * TILE_SIZE) - 1) {
@@ -704,7 +731,8 @@
 	}
 
 	DisasterVehicle *v = new DisasterVehicle();
-	InitializeDisasterVehicle(v, x, 0, INITIAL_DISASTER_VEHICLE_ZPOS, DIR_SE, ST_ZEPPELINER);
+	int z = GetAircraftMinAltitude(x, 0, 0);
+	InitializeDisasterVehicle(v, x, 0, z, DIR_SE, ST_ZEPPELINER);
 
 	/* Allocate shadow */
 	DisasterVehicle *u = new DisasterVehicle();
@@ -725,7 +753,8 @@
 	DisasterVehicle *v = new DisasterVehicle();
 	int x = TileX(Random()) * TILE_SIZE + TILE_SIZE / 2;
 
-	InitializeDisasterVehicle(v, x, 0, INITIAL_DISASTER_VEHICLE_ZPOS, DIR_SE, ST_SMALL_UFO);
+	int z = GetAircraftMinAltitude(x, 0, 0);
+	InitializeDisasterVehicle(v, x, 0, z, DIR_SE, ST_SMALL_UFO);
 	v->dest_tile = TileXY(MapSizeX() / 2, MapSizeY() / 2);
 	v->age = 0;
 
@@ -759,7 +788,8 @@
 	int x = (MapSizeX() + 9) * TILE_SIZE - 1;
 	int y = TileY(found->location.tile) * TILE_SIZE + 37;
 
-	InitializeDisasterVehicle(v, x, y, INITIAL_DISASTER_VEHICLE_ZPOS, DIR_NE, ST_AIRPLANE);
+	int z = GetAircraftMinAltitude(x, y, 0);
+	InitializeDisasterVehicle(v, x, y, z, DIR_NE, ST_AIRPLANE);
 
 	DisasterVehicle *u = new DisasterVehicle();
 	v->SetNext(u);
@@ -789,7 +819,8 @@
 	int x = -16 * (int)TILE_SIZE;
 	int y = TileY(found->location.tile) * TILE_SIZE + 37;
 
-	InitializeDisasterVehicle(v, x, y, INITIAL_DISASTER_VEHICLE_ZPOS, DIR_SW, ST_HELICOPTER);
+	int z = GetAircraftMinAltitude(x, y, 0);
+	InitializeDisasterVehicle(v, x, y, z, DIR_SW, ST_HELICOPTER);
 
 	DisasterVehicle *u = new DisasterVehicle();
 	v->SetNext(u);
@@ -798,7 +829,7 @@
 
 	DisasterVehicle *w = new DisasterVehicle();
 	u->SetNext(w);
-	InitializeDisasterVehicle(w, x, y, 140, DIR_SW, ST_HELICOPTER_ROTORS);
+	InitializeDisasterVehicle(w, x, y, z + 5, DIR_SW, ST_HELICOPTER_ROTORS);
 }
 
 
@@ -812,7 +843,8 @@
 	int x = TileX(Random()) * TILE_SIZE + TILE_SIZE / 2;
 	int y = MapMaxX() * TILE_SIZE - 1;
 
-	InitializeDisasterVehicle(v, x, y, INITIAL_DISASTER_VEHICLE_ZPOS, DIR_NW, ST_BIG_UFO);
+	int z = GetAircraftMinAltitude(x, y, 0);
+	InitializeDisasterVehicle(v, x, y, z, DIR_NW, ST_BIG_UFO);
 	v->dest_tile = TileXY(MapSizeX() / 2, MapSizeY() / 2);
 	v->age = 0;
 
diff --git a/src/economy.cpp b/src/economy.cpp
--- a/src/economy.cpp
+++ b/src/economy.cpp
@@ -46,6 +46,8 @@
 #include "core/pool_func.hpp"
 #include "newgrf.h"
 #include "core/backup_type.hpp"
+#include "infrastructure_func.h"
+#include "cheat_type.h"
 
 #include "table/strings.h"
 #include "table/pricebase.h"
@@ -415,7 +417,8 @@
 		}
 	}
 
-	{
+	/* Change ownership of vehicles */
+	if (new_owner != INVALID_OWNER) {
 		FreeUnitIDGenerator unitidgen[] = {
 			FreeUnitIDGenerator(VEH_TRAIN, new_owner), FreeUnitIDGenerator(VEH_ROAD,     new_owner),
 			FreeUnitIDGenerator(VEH_SHIP,  new_owner), FreeUnitIDGenerator(VEH_AIRCRAFT, new_owner)
@@ -457,22 +460,14 @@
 			 * and signals were not propagated
 			 * Similiar with crossings - it is needed to bar crossings that weren't before
 			 * because of different owner of crossing and approaching train */
-			tile = 0;
-
-			do {
-				if (IsTileType(tile, MP_RAILWAY) && IsTileOwner(tile, new_owner) && HasSignals(tile)) {
-					TrackBits tracks = GetTrackBits(tile);
-					do { // there may be two tracks with signals for TRACK_BIT_HORZ and TRACK_BIT_VERT
-						Track track = RemoveFirstTrack(&tracks);
-						if (HasSignalOnTrack(tile, track)) AddTrackToSignalBuffer(tile, track, new_owner);
-					} while (tracks != TRACK_BIT_NONE);
-				} else if (IsLevelCrossingTile(tile) && IsTileOwner(tile, new_owner)) {
-					UpdateLevelCrossing(tile);
-				}
-			} while (++tile != MapSize());
+			UpdateAllBlockSignals(new_owner);
+		} else if (_settings_game.economy.infrastructure_sharing[VEH_TRAIN]) {
+			/* tracks are being removed while sharing is enabled.
+			 * Thus, update all signals and crossings. */
+			UpdateAllBlockSignals();
 		}
 
-		/* update signals in buffer */
+		/* Update any signals in the buffer */
 		UpdateSignalsInBuffer();
 	}
 
@@ -990,8 +985,11 @@
 
 	/* Increase town's counter for some special goods types */
 	const CargoSpec *cs = CargoSpec::Get(cargo_type);
+	if (cs->town_effect == TE_PASSENGERS) st->town->new_act_pass += accepted;
+	if (cs->town_effect == TE_MAIL) st->town->new_act_mail += accepted;
 	if (cs->town_effect == TE_FOOD) st->town->new_act_food += accepted;
 	if (cs->town_effect == TE_WATER) st->town->new_act_water += accepted;
+	if (cs->town_effect == TE_GOODS) st->town->new_act_goods += accepted;
 
 	/* Determine profit */
 	Money profit = GetTransportedGoodsIncome(accepted, DistanceManhattan(source_tile, st->xy), days_in_transit, cargo_type);
@@ -1060,21 +1058,23 @@
 
 	this->front->cargo_payment = NULL;
 
-	if (this->visual_profit == 0) return;
+	if (this->visual_profit == 0 && this->visual_transfer == 0) return;
 
 	Backup<CompanyByte> cur_company(_current_company, this->front->owner, FILE_LINE);
 
 	SubtractMoneyFromCompany(CommandCost(this->front->GetExpenseType(true), -this->route_profit));
-	this->front->profit_this_year += this->visual_profit << 8;
+	this->front->profit_this_year += (this->visual_profit + this->visual_transfer) << 8;
 
-	if (this->route_profit != 0) {
-		if (IsLocalCompany() && !PlayVehicleSound(this->front, VSE_LOAD_UNLOAD)) {
-			SndPlayVehicleFx(SND_14_CASHTILL, this->front);
-		}
+	if (this->route_profit != 0 && IsLocalCompany() && !PlayVehicleSound(this->front, VSE_LOAD_UNLOAD)) {
+		SndPlayVehicleFx(SND_14_CASHTILL, this->front);
+	}
 
-		ShowCostOrIncomeAnimation(this->front->x_pos, this->front->y_pos, this->front->z_pos, -this->visual_profit);
-	} else {
-		ShowFeederIncomeAnimation(this->front->x_pos, this->front->y_pos, this->front->z_pos, this->visual_profit);
+	if (this->visual_transfer != 0){
+		ShowFeederIncomeAnimation(this->front->x_pos, this->front->y_pos,
+				this->front->z_pos, this->visual_transfer, -this->visual_profit);
+	} else if (this->visual_profit) {
+		ShowCostOrIncomeAnimation(this->front->x_pos, this->front->y_pos,
+				this->front->z_pos, -this->visual_profit);
 	}
 
 	cur_company.Restore();
@@ -1091,8 +1091,32 @@
 		this->owner = Company::Get(this->front->owner);
 	}
 
-	/* Handle end of route payment */
+	/* Handle end of route payment */ //TODO: Adjust profit to daylength factor (fractional)
 	Money profit = DeliverGoods(count, this->ct, this->current_station, cp->SourceStationXY(), cp->DaysInTransit(), this->owner, cp->SourceSubsidyType(), cp->SourceSubsidyID());
+
+/* Devide profit by daylength and keep the restfraction for the next payment. */
+/* test 1 */
+//profit = (profit * 100) << 16;
+//daylength_money_fraction += profit;
+//daylength_money_payout = daylength_money_fraction / _date_daylength_factor;
+//daylength_money_fraction = daylength_money_fraction - daylength_money_payout * _date_daylength_factor;
+//profit = (daylength_money_payout / 100) >> 16;
+
+/* test 2*/
+//daylength_money_payout = profit / _date_daylength_factor;
+//daylength_money_fraction = daylength_money_fraction + profit - daylength_money_payout * _date_daylength_factor; // "(t - m * daylength)" is always < daylength so f is never big
+//daylength_money_payout = daylength_money_payout + daylength_money_fraction / _date_daylength_factor;
+//daylength_money_fraction = daylength_money_fraction - daylength_money_payout * _date_daylength_factor;
+//profit = daylength_money_payout;
+
+
+	/* Devide income by daylength factor. */
+	if (!_cheats.daylength_income.value) {
+		profit = profit / _date_daylength_factor;
+		/* Pay something when the income is too low after devision by daylength. */
+		if (_date_daylength_factor > 1 && profit < 1) profit = 1;
+	}
+
 	this->route_profit += profit;
 
 	/* The vehicle's profit is whatever route profit there is minus feeder shares. */
@@ -1112,27 +1136,67 @@
 			/* pay transfer vehicle for only the part of transfer it has done: ie. cargo_loaded_at_xy to here */
 			DistanceManhattan(cp->LoadedAtXY(), Station::Get(this->current_station)->xy),
 			cp->DaysInTransit(),
-			this->ct);
+			this->ct);  //TODO: Adjust profit to daylength factor (fractional)
+
+
+/* Devide profit by daylength and keep the restfraction for the next payment. */
+/* test 1*/
+//profit = (profit * 100) << 16;
+//daylength_money_fraction += profit;
+//daylength_money_payout = daylength_money_fraction / _date_daylength_factor;
+//daylength_money_fraction = daylength_money_fraction - daylength_money_payout * _date_daylength_factor;
+//profit = (daylength_money_payout / 100) >> 16;
+
+/*test 2*/
+//daylength_money_payout = profit / _date_daylength_factor;
+//daylength_money_fraction = daylength_money_fraction + profit - daylength_money_payout * _date_daylength_factor; // "(t - m * daylength)" is always < daylength so f is never big
+//daylength_money_payout = daylength_money_payout + daylength_money_fraction / _date_daylength_factor;
+//daylength_money_fraction = daylength_money_fraction - daylength_money_payout * _date_daylength_factor;
+//profit = daylength_money_payout;
+
+	/* Devide income by daylength factor. */
+	if (!_cheats.daylength_income.value) {
+		profit = profit / _date_daylength_factor;
+		/* Pay something when the income is too low after devision by daylength. */
+		if (_date_daylength_factor > 1 && profit < 1) profit = 1;
+	}
 
 	profit = profit * _settings_game.economy.feeder_payment_share / 100;
 
-	this->visual_profit += profit; // accumulate transfer profits for whole vehicle
+	this->visual_transfer += profit; // accumulate transfer profits for whole vehicle
 	return profit; // account for the (virtual) profit already made for the cargo packet
 }
 
 /**
  * Prepare the vehicle to be unloaded.
+ * @param curr_station the station where the consist is at the moment
  * @param front_v the vehicle to be unloaded
+ * @param next_station_id id of the station the consist will be traveling next
  */
-void PrepareUnload(Vehicle *front_v)
+void PrepareUnload(Station *curr_station, Vehicle *front_v, StationID next_station_id)
 {
 	/* At this moment loading cannot be finished */
 	ClrBit(front_v->vehicle_flags, VF_LOADING_FINISHED);
 
-	/* Start unloading in at the first possible moment */
+	/* Start unloading at the first possible moment */
 	front_v->load_unload_ticks = 1;
 
-	if ((front_v->current_order.GetUnloadType() & OUFB_NO_UNLOAD) == 0) {
+	if ((front_v->current_order.GetUnloadType() & OUFB_NO_UNLOAD) != 0) {
+		/* vehicle will keep all its cargo and LoadUnloadVehicle will never call MoveToStation,
+		 * so we have to update the flow stats here.
+		 */
+		if (next_station_id == INVALID_STATION) {
+			return;
+		} else {
+			for (Vehicle *v = front_v; v != NULL; v = v->Next()) {
+				const CargoPacketList *packets = v->cargo.Packets();
+				for(VehicleCargoList::ConstIterator i(packets->begin()); i != packets->end(); ++i) {
+					curr_station->goods[v->cargo_type].UpdateFlowStats(
+							(*i)->SourceStation(), (*i)->Count(), next_station_id);
+				}
+			}
+		}
+	} else {
 		for (Vehicle *v = front_v; v != NULL; v = v->Next()) {
 			if (v->cargo_cap > 0 && !v->cargo.Empty()) {
 				SetBit(v->vehicle_flags, VF_CARGO_UNLOADING);
@@ -1360,39 +1424,29 @@
 
 		/* If there's goods waiting at the station, and the vehicle
 		 * has capacity for it, load it on the vehicle. */
-		int cap_left = v->cargo_cap - v->cargo.Count();
-		if (!ge->cargo.Empty() && cap_left > 0) {
-			uint cap = cap_left;
-			uint count = ge->cargo.Count();
+		int cap_left = v->cargo_cap - v->cargo.OnboardCount();
+		if (cap_left > 0) {
+			if (_settings_game.order.gradual_loading) cap_left = min(cap_left, load_amount);
+			if (v->cargo.Empty()) TriggerVehicle(v, VEHICLE_TRIGGER_NEW_CARGO);
 
-			/* Skip loading this vehicle if another train/vehicle is already handling
-			 * the same cargo type at this station */
-			if (_settings_game.order.improved_load && cargo_left[v->cargo_type] <= 0) {
-				SetBit(cargo_not_full, v->cargo_type);
-				continue;
+			int loaded = 0;
+
+			if (_settings_game.order.improved_load) {
+				loaded += v->cargo.LoadReserved(cap_left);
 			}
 
-			if (cap > count) cap = count;
-			if (_settings_game.order.gradual_loading) {
-				cap = min(cap, load_amount);
-				cap_left = min(cap_left, load_amount);
-			}
-			if (_settings_game.order.improved_load) {
-				/* Don't load stuff that is already 'reserved' for other vehicles */
-				cap = min((uint)cargo_left[v->cargo_type], cap);
-				count = cargo_left[v->cargo_type];
-				cargo_left[v->cargo_type] -= cap;
+			if (loaded < cap_left) {
+				assert(v->cargo.ReservedCount() == 0);
+				loaded += ge->cargo.MoveTo(&v->cargo, cap_left - loaded, next_station);
 			}
 
 			/* Store whether the maximum possible load amount was loaded or not.*/
-			if (count >= (uint)cap_left) {
+			if (loaded == cap_left) {
 				SetBit(full_load_amount, v->cargo_type);
 			} else {
 				ClrBit(full_load_amount, v->cargo_type);
 			}
 
-			if (v->cargo.Empty()) TriggerVehicle(v, VEHICLE_TRIGGER_NEW_CARGO);
-
 			/* TODO: Regarding this, when we do gradual loading, we
 			 * should first unload all vehicles and then start
 			 * loading them. Since this will cause
@@ -1521,6 +1575,7 @@
 		st->MarkTilesDirty(true);
 		SetWindowDirty(WC_STATION_VIEW, last_visited);
 	}
+	return cargos_reserved;
 }
 
 /**
@@ -1555,13 +1610,11 @@
 	 */
 	if (last_loading == NULL) return;
 
-	int cargo_left[NUM_CARGO];
-
-	for (uint i = 0; i < NUM_CARGO; i++) cargo_left[i] = st->goods[i].cargo.Count();
+	uint cargos_reserved = 0;
 
 	for (iter = st->loading_vehicles.begin(); iter != st->loading_vehicles.end(); ++iter) {
 		Vehicle *v = *iter;
-		if (!(v->vehstatus & (VS_STOPPED | VS_CRASHED))) LoadUnloadVehicle(v, cargo_left);
+		if (!(v->vehstatus & (VS_STOPPED | VS_CRASHED))) cargos_reserved = LoadUnloadVehicle(v, cargos_reserved);
 		if (v == last_loading) break;
 	}
 
@@ -1583,6 +1636,7 @@
 		AddInflation();
 		RecomputePrices();
 	}
+
 	CompaniesPayInterest();
 	HandleEconomyFluctuations();
 }
diff --git a/src/economy_base.h b/src/economy_base.h
--- a/src/economy_base.h
+++ b/src/economy_base.h
@@ -24,9 +24,12 @@
  * Helper class to perform the cargo payment.
  */
 struct CargoPayment : CargoPaymentPool::PoolItem<&_cargo_payment_pool> {
-	Vehicle *front;      ///< The front vehicle to do the payment of
-	Money route_profit;  ///< The amount of money to add/remove from the bank account
-	Money visual_profit; ///< The visual profit to show
+	Vehicle *front;        ///< The front vehicle to do the payment of
+	Money route_profit;    ///< The amount of money to add/remove from the bank account
+	Money visual_profit;   ///< The visual profit to show
+	Money visual_transfer; ///< The transfer credits to be shown
+int daylength_money_payout;   ///< Amount of money to be paid out now.
+int daylength_money_fraction; ///< Amount of money we will keep for the next time.
 
 	/* Unsaved variables */
 	Company *owner;            ///< The owner of the vehicle
diff --git a/src/economy_func.h b/src/economy_func.h
--- a/src/economy_func.h
+++ b/src/economy_func.h
@@ -33,7 +33,7 @@
 Money GetTransportedGoodsIncome(uint num_pieces, uint dist, byte transit_days, CargoID cargo_type);
 uint MoveGoodsToStation(CargoID type, uint amount, SourceType source_type, SourceID source_id, const StationList *all_stations);
 
-void PrepareUnload(Vehicle *front_v);
+void PrepareUnload(Station *curr_station, Vehicle *front_v, StationID next_station_id);
 void LoadUnloadStation(Station *st);
 
 Money GetPrice(Price index, uint cost_factor, const struct GRFFile *grf_file, int shift = 0);
diff --git a/src/economy_type.h b/src/economy_type.h
--- a/src/economy_type.h
+++ b/src/economy_type.h
@@ -155,6 +155,8 @@
 	EXPENSES_AIRCRAFT_INC,        ///< Income from aircrafts.
 	EXPENSES_SHIP_INC,            ///< Income from ships.
 	EXPENSES_LOAN_INT,            ///< Interest payments over the loan.
+	EXPENSES_SHARING_COST,        ///< Infrastructure sharing costs
+	EXPENSES_SHARING_INC,         ///< Infrastructure sharing income
 	EXPENSES_OTHER,               ///< Other expenses.
 	EXPENSES_END,                 ///< Number of expense types.
 	INVALID_EXPENSES      = 0xFF, ///< Invalid expense type.
diff --git a/src/fios.cpp b/src/fios.cpp
--- a/src/fios.cpp
+++ b/src/fios.cpp
@@ -135,6 +135,7 @@
 		case FIOS_TYPE_OLD_SCENARIO:
 		case FIOS_TYPE_PNG:
 		case FIOS_TYPE_BMP:
+		case FIOS_TYPE_TEMPLATE:
 			return item->name;
 	}
 
@@ -153,6 +154,13 @@
 {
 	const char *period;
 
+//<<<<<<< .mine  // Todo: remove after testing
+//	extension = (_game_mode == GM_EDITOR) ? ".scn" : ".sav";
+//	if (_saveload_mode == SLD_SAVE_TEMPLATE || _saveload_mode == SLD_LOAD_TEMPLATE) {
+//		extension = ".tmpl";
+//	}
+//=======
+//>>>>>>> .r22515
 	/* Don't append the extension if it is already there */
 	period = strrchr(name, '.');
 	if (period != NULL && strcasecmp(period, ext) == 0) ext = "";
@@ -181,7 +189,13 @@
  */
 void FiosMakeSavegameName(char *buf, const char *name, size_t size)
 {
-	const char *extension = (_game_mode == GM_EDITOR) ? ".scn" : ".sav";
+	const char *extension;
+
+	if (_saveload_mode == SLD_SAVE_TEMPLATE || _saveload_mode == SLD_LOAD_TEMPLATE) {
+		extension = ".tmpl";
+	} else {
+		extension = (_game_mode == GM_EDITOR) ? ".scn" : ".sav";
+	}
 
 	FiosMakeFilename(buf, _fios_path, name, extension, size);
 }
@@ -436,6 +450,45 @@
 }
 
 /**
+ * Callback for FiosGetFileList. It tells if a file is a template or not.
+ * @param mode Save/load mode.
+ * @param file Name of the file to check.
+ * @param ext A pointer to the extension identifier inside file
+ * @param title Buffer if a callback wants to lookup the title of the file
+ * @return a FIOS_TYPE_* type of the found file, FIOS_TYPE_INVALID if not a template
+ * @see FiosGetFileList
+ * @see FiosGetSavegameList
+ */
+static FiosType FiosGetTemplateListCallback(SaveLoadDialogMode mode, const char *file, const char *ext, char *title, const char *last)
+{
+	/* Show template files
+	 * .tmpl OpenTTD template */
+	if (strcasecmp(ext, ".tmpl") == 0) return FIOS_TYPE_TEMPLATE;
+
+	return FIOS_TYPE_INVALID;
+}
+
+/**
+ * Get a list of templates.
+ * @param mode Save/load mode.
+ * @return A pointer to an array of FiosItem representing all the files to be shown in the save/load dialog.
+ * @see FiosGetFileList
+ */
+void FiosGetTemplateList(SaveLoadDialogMode mode)
+{
+	static char *_fios_save_path = NULL;
+
+	if (_fios_save_path == NULL) {
+		_fios_save_path = MallocT<char>(MAX_PATH);
+		FioGetDirectory(_fios_save_path, MAX_PATH, SAVE_DIR);
+	}
+
+	_fios_path = _fios_save_path;
+
+	FiosGetFileList(mode, &FiosGetTemplateListCallback, NO_DIRECTORY);
+}
+
+/**
  * Callback for FiosGetFileList. It tells if a file is a scenario or not.
  * @param mode Save/load mode.
  * @param file Name of the file to check.
diff --git a/src/fios.h b/src/fios.h
--- a/src/fios.h
+++ b/src/fios.h
@@ -90,9 +90,11 @@
 	/** First slot useable for (New)GRFs used during the game. */
 	FIRST_GRF_SLOT =  2,
 	/** Last slot useable for (New)GRFs used during the game. */
-	LAST_GRF_SLOT  = 63,
+	LAST_GRF_SLOT  = 255,
 	/** Maximum number of slots. */
-	MAX_FILE_SLOTS = 64
+	MAX_FILE_SLOTS = 256,
+	/** Maximum number of slots for network game */
+	MAX_FILE_SLOTS_IN_NETWORK = 63
 };
 
 /** Mode of the file dialogue window. */
@@ -103,6 +105,9 @@
 	SLD_SAVE_SCENARIO,  ///< Save a scenario.
 	SLD_LOAD_HEIGHTMAP, ///< Load a heightmap.
 	SLD_SAVE_HEIGHTMAP, ///< Save a heightmap.
+	SLD_SAVE_TEMPLATE,
+	SLD_LOAD_TEMPLATE,
+	SLD_NEW_GAME,
 };
 
 /** The different types of files that the system knows about. */
@@ -124,6 +129,7 @@
 	FIOS_TYPE_DIRECT,
 	FIOS_TYPE_PNG,
 	FIOS_TYPE_BMP,
+	FIOS_TYPE_TEMPLATE,
 	FIOS_TYPE_INVALID = 255,
 };
 
@@ -162,7 +168,9 @@
 void FiosGetSavegameList(SaveLoadDialogMode mode);
 void FiosGetScenarioList(SaveLoadDialogMode mode);
 void FiosGetHeightmapList(SaveLoadDialogMode mode);
-
+/* Get a list of templates */
+void FiosGetTemplateList(SaveLoadDialogMode mode);
+/* Free the list of savegames */
 void FiosFreeSavegameList();
 const char *FiosBrowseTo(const FiosItem *item);
 
